﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ZedGraph;
using System.IO.Ports;

namespace 温度上位机
{
    public partial class Drawer : Form
    {
       
        PointPairList list = new PointPairList();
        LineItem myCurve;
        public Drawer()
        {           
            InitializeComponent();
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(port_DataReceived);
            System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = false;
            
        }
        byte[] data = new byte[8];
        byte[] num1 = new byte[100];
        byte[] num11 = new byte[100];
        private void port_DataReceived(object sender, SerialDataReceivedEventArgs e)//用于串口数据的接受
        {
            try
            {

                serialPort1.Read(data, 2, 1);
            //    textBox1.AppendText(data[2] + "  ");

                if (data[0] == 0x01)
                {
                    for (int i = 99; i > 0; i--)
                    {
                        num1[i] = num1[i - 1];
                        num11[i] = num11[i - 1];
                    }
                    num1[0] = data[1];
                    num11[0] = data[2];
                    data[0] = 0;
                    data[1] = 0;
                    data[2] = 0;
                    //  textBox2.Clear();
               //     textBox2.Text = " " + num1[0].ToString() + "." + num11[0].ToString();

                }
                else
                {
                    data[0] = data[1];
                    data[1] = data[2];

                }
            }
            catch
            {
                MessageBox.Show("出现异常！");
            }
        }
        private void Drawer_Load(object sender, EventArgs e)
        {

            serialPort1.DataBits = 8; //数据位
            serialPort1.Parity = System.IO.Ports.Parity.None;//无奇偶校验位
            serialPort1.StopBits = System.IO.Ports.StopBits.One; //一个停止位
            serialPort1.ReadBufferSize = 1024; //接收缓冲区大小
            serialPort1.ReadTimeout = 1500;
            serialPort1.WriteTimeout = 2000;
            serialPort1.PortName = "COM7";
            serialPort1.BaudRate = 9600;
            serialPort1.Open();
            timer1.Start();
         //   button4.Enabled = false;



            this.zedGraphControl1.GraphPane.Title.Text = "温度曲线图";
            this.zedGraphControl1.GraphPane.XAxis.Title.Text = "时间";
            this.zedGraphControl1.GraphPane.YAxis.Title.Text = "温度";
            this.zedGraphControl1.GraphPane.XAxis.Type = ZedGraph.AxisType.DateAsOrdinal;
            for (int i = 0; i <= 100; i++)
            {
                double x = (double)new XDate(DateTime.Now.AddSeconds(-(100 - i)));
                double y = Convert.ToDouble(num1[0].ToString() + "." + num11[0].ToString());
                list.Add(x, y);
            }
            DateTime dt = DateTime.Now;
            myCurve = zedGraphControl1.GraphPane.AddCurve("myCurve", list, Color.DarkBlue, SymbolType.None);
            this.zedGraphControl1.AxisChange();
            this.zedGraphControl1.Refresh();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            zedGraphControl1.GraphPane.XAxis.Scale.MaxAuto = true;
            double x = (double)new XDate(DateTime.Now);
            double y = Convert.ToDouble(num1[0].ToString() + "." + num11[0].ToString());
            list.Add(x, y);
            this.zedGraphControl1.AxisChange();
            this.zedGraphControl1.Refresh();
            
        }

       
    }

}
   
   
